<?php

namespace Ulmus\User\Authorize;

use Psr\Http\Message\ServerRequestInterface;
use Ulmus\User\Entity\UserInterface;
use Ulmus\User\Lib\Authenticate;

class PostRequestAuthentication implements AuthorizeMethodInterface
{
    public function __construct(
        public Authenticate $authenticate,
        protected string $fieldUser = "email",
        protected string $postFieldUser = "email",
        protected string $postFieldPassword = "password",
    ) {}

    public function connect(ServerRequestInterface $request, UserInterface $user): bool
    {
        $post = $request->getParsedBody();

        return $this->authenticate->authenticate([ $this->fieldUser => $post[$this->postFieldUser] ], $post[$this->postFieldPassword]);
    }

    public function catchRequest(ServerRequestInterface $request): bool
    {
        $post = $request->getParsedBody();

        return strtoupper( $request->getMethod() ) === "POST" && isset($post[$this->postFieldUser], $post[$this->postFieldPassword]);
    }
}